zoukankan      html  css  js  c++  java
  • UVA12563 劲歌金曲

    题目:劲歌金曲

    网址:https://onlinejudge.org/index.php?option=com_onlinejudge&Itemid=8&category=444&page=show_problem&problem=4008

    There is one very popular song called Jin Ge Jin Qu(). It is a mix of 37 songs, and is extremely
    long (11 minutes and 18 seconds) — I know that there are Jin Ge Jin Qu II and III, and some other
    unofficial versions. But in this problem please forget about them.

    Why is it popular?

    Suppose you have only 15 seconds left (until your time is up), then you should
    select another song as soon as possible, because the KTV will not crudely stop a song before it ends
    (people will get frustrated if it does so!). If you select a 2-minute song, you actually get 105 extra
    seconds! ....and if you select Jin Ge Jin Qu, you’ll get 663 extra seconds!!!

    Now that you still have some time, but you’d like to make a plan now. You should stick to the
    following rules:

    • Don’t sing a song more than once (including Jin Ge Jin Qu).
    • For each song of length t, either sing it for exactly t seconds, or don’t sing it at all.
    • When a song is finished, always immediately start a new song.

    Your goal is simple: sing as many songs as possible, and leave KTV as late as possible (since we
    have rule 3, this also maximizes the total lengths of all songs we sing) when there are ties.

    Input

    The first line contains the number of test cases T (T ≤ 100). Each test case begins with two positive
    integers n, t (1 ≤ n ≤ 50, 1 ≤ t ≤ 10^9
    ), the number of candidate songs (BESIDES Jin Ge Jin Qu)
    and the time left (in seconds). The next line contains n positive integers, the lengths of each song, in
    seconds. Each length will be less than 3 minutes — I know that most songs are longer than 3 minutes.
    But don’t forget that we could manually “cut” the song after we feel satisfied, before the song ends.

    So here “length” actually means “length of the part that we want to sing”.
    It is guaranteed that the sum of lengths of all songs (including Jin Ge Jin Qu) will be strictly larger
    than t.

    Output

    For each test case, print the maximum number of songs (including Jin Ge Jin Qu), and the total lengths
    of songs that you’ll sing.

    Explanation:

    In the first example, the best we can do is to sing the third song (80 seconds), then Jin Ge Jin Qu
    for another 678 seconds.

    In the second example, we sing the first two (30+69=99 seconds). Then we still have one second
    left, so we can sing Jin Ge Jin Qu for extra 678 seconds. However, if we sing the first and third song
    instead (30+70=100 seconds), the time is already up (since we only have 100 seconds in total), so we
    can’t sing Jin Ge Jin Qu anymore!

    Sample Input
    2
    3 100
    60 70 80
    3 100
    30 69 70
    
    Sample Output
    Case 1: 2 758
    Case 2: 3 777
    

    很棒的一道背包问题。
    首先,题目的t数据规模很大,但实际上总曲目的时间要大于t,通过计算可以知道,t最大为180 * n + 678 <= 90000。

    然后呢?

    然后把时间看作体积,数目为价值进行0-1背包。

    注意初始化时,由于要求出最长时间,所以让dp[1 ~ t]均为负无穷,dp[0] = 0。(从题目要求想较为易)

    代码如下:

    #include<iostream>
    #include<cstring>
    #include<cstdio>
    #include<cmath>
    using namespace std;
    const int maxn = 55, maxt = 9000 + 10;
    int n, t, time[maxn], dp[maxt];
    int main()
    {
    	int T;
    	scanf("%d", &T);
    	for(int p = 1; p <= T; ++ p)
    	{
    		scanf("%d %d", &n, &t);
    		int sum = 678;
    		for(int i = 1; i <= n; ++ i)
    		{
    			scanf("%d", &time[i]);
    			sum += time[i];
    		}
    		if(t >= sum)
    		{
    			printf("Case %d: %d %d
    ", p, n, sum);
    			continue;
    		}
    		memset(dp, 0xcf, sizeof(dp));
    		dp[0] = 0;
    		for(int i = 1; i <= n; ++ i)
    		{
    			for(int j = t; j >= 0; -- j)
    			{
    				if(j >= time[i]) dp[j] = max(dp[j], dp[j - time[i]] + 1);
    			}
    		}
    		int ans = -1, cnt = -1;
    		for(int i = 677; i; -- i)
    		{
    			if(t + i - 677 > 0)
    			{
    				if(ans < dp[t + i - 678] + 1)
    				{
    					ans = dp[t + i - 678] + 1;
    					cnt = t + i;
    				}
    			}
    		}
    		printf("Case %d: %d %d
    ", p, ans, cnt);
    	}
    	return 0;
    }
    
  • 相关阅读:
    日期时间插件
    QQ在线客服
    dede轮播图
    Animation 案例解释
    transition Css3过度详解
    解决文字无法缩小的问题
    DEDE函数
    hdu 3435 图回路分割
    HDU 4183
    hdu 1569 最小割
  • 原文地址:https://www.cnblogs.com/zach20040914/p/13089659.html
Copyright © 2011-2022 走看看